> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

> Retrieves a paginated list of API tools for the application. Use this endpoint to browse and manage custom API tool configurations.

# List API Tools

For the complete error reference, see [Error Guide](/rest-api/ai-agents-apis/error-codes).


## OpenAPI

````yaml get /ai-agents/agent-builder/api-tools
openapi: 3.0.0
info:
  title: AI Agents APIs
  description: API reference for CometChat AI Agents service
  version: '1.0'
servers:
  - url: https://{appId}.api-{region}.cometchat.io/v3
    variables:
      appId:
        default: appId
        description: (Required) App ID
      region:
        enum:
          - us
          - eu
          - in
        default: us
        description: Select Region
security: []
tags:
  - name: ai-agent
    description: ''
paths:
  /ai-agents/agent-builder/api-tools:
    get:
      tags:
        - Agent Builder API Tools
      summary: List API Tools
      description: >-
        Retrieves a paginated list of API tools for the application. Use this
        endpoint to browse and manage custom API tool configurations.
      operationId: ApiToolsController_getAllApiTools
      parameters:
        - name: limit
          required: false
          in: query
          schema:
            type: number
          description: Maximum number of results to return per page.
        - name: affix
          required: false
          in: query
          schema:
            enum:
              - prepend
              - append
            type: string
          description: >-
            To paginate over results, use the value of affix as prepend or
            append.
        - name: createdAt
          required: false
          in: query
          schema:
            type: number
          description: To be used with affix for pagination.
      responses:
        '200':
          description: Paginated list of API tools
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    type: array
                    items:
                      type: object
                      properties:
                        _id:
                          type: string
                          example: myapp_my-api-tool
                        appId:
                          type: string
                          example: my-app-id
                        slug:
                          type: string
                          example: my-api-tool
                        name:
                          type: string
                          example: My API Tool
                        description:
                          type: string
                          example: Calls an external API
                        icon:
                          type: string
                          example: https://example.com/icon.png
                        endpoint:
                          type: string
                          example: https://api.example.com/search
                        method:
                          type: string
                          example: GET
                        enableBasicAuth:
                          type: boolean
                          example: false
                        headers:
                          type: string
                          nullable: true
                          example: '{"Content-Type":"application/json"}'
                        bodyTemplate:
                          type: string
                          nullable: true
                          example: '{"query":"{{query}}"}'
                        allowAdditionalProperties:
                          type: boolean
                          example: false
                        parameters:
                          type: array
                          items:
                            type: object
                            properties:
                              key:
                                type: string
                                example: query
                              type:
                                type: string
                                example: string
                              description:
                                type: string
                                example: The search query
                              required:
                                type: boolean
                                example: true
                        tool:
                          type: object
                          properties:
                            name:
                              type: string
                              example: my-api-tool
                            description:
                              type: string
                              example: Calls an external API
                            parameters:
                              type: object
                              example:
                                type: object
                                properties: {}
                                required: []
                        createdAt:
                          type: number
                          example: 1700000000000
                        updatedAt:
                          type: number
                          example: 1700000000000
                  meta:
                    type: object
                    properties:
                      previous:
                        type: object
                        example:
                          affix: prepend
                          createdAt: 1700000000000
                      current:
                        type: object
                        example:
                          limit: 10
                          count: 5
                      next:
                        type: object
                        example:
                          affix: append
                          createdAt: 1700000000000
              example:
                data:
                  - _id: myapp_my-api-tool
                    appId: my-app-id
                    slug: my-api-tool
                    name: My API Tool
                    description: Calls an external API
                    icon: https://example.com/icon.png
                    endpoint: https://api.example.com/search
                    method: GET
                    enableBasicAuth: false
                    headers: '{"Content-Type":"application/json"}'
                    bodyTemplate: '{"query":"{{query}}"}'
                    allowAdditionalProperties: false
                    parameters:
                      - key: query
                        type: string
                        description: The search query
                        required: true
                    tool:
                      name: my-api-tool
                      description: Calls an external API
                      parameters:
                        type: object
                        properties: {}
                        required: []
                    createdAt: 1700000000000
                    updatedAt: 1700000000000
                meta:
                  previous:
                    affix: prepend
                    createdAt: 1700000000000
                  current:
                    limit: 10
                    count: 1
                  next:
                    affix: append
                    createdAt: 1700000000000
      security:
        - apiKey: []
components:
  securitySchemes:
    apiKey:
      type: apiKey
      description: API Key (i.e. Rest API Key from the Dashboard).
      name: apikey
      in: header

````